#renderer

from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *
import pygame



import lib.texture_manager

camera_pos = [5,5,20]

def draw_coloured_square (pos,colour,size = 1):
    x,y=pos
    s=float(size)/2
    glColor (*colour)
    
    glBegin(GL_QUADS)
    glVertex2f(x-s,y+s)
    glVertex2f(x+s,y+s)
    glVertex2f(x+s,y-s)
    glVertex2f(x-s,y-s)
    glEnd()
 
def draw_square (pos,size=1):
    s=size/2.0
    glBegin( GL_QUADS );
    glTexCoord2d(0.0,0.0); glVertex2d(-s,-s);
    glTexCoord2d(1.0,0.0); glVertex2d(s,-s);
    glTexCoord2d(1.0,1.0); glVertex2d(s,s);
    glTexCoord2d(0.0,1.0); glVertex2d(-s,s);
    glEnd();  

def draw_offset_square (s,colour,size):
    glPushMatrix()
    glTranslate (0,0,s)
    draw_square ([0,0],size)
    glPopMatrix()

def draw_box (pos,colour = [1,1,1],size = 1, tex = -1):
    glPushMatrix()
    glTranslatef (*pos)
    s=size/2.0
    glMaterialfv (GL_FRONT,GL_DIFFUSE,colour)
    draw_offset_square (s,colour,size)
    glRotatef (90,1,0,0)
    draw_offset_square (s,colour,size)
    glRotatef (180,1,0,0)
    draw_offset_square (s,colour,size)
    glRotatef (90,1,0,0)
    glRotatef (90,0,1,0)
    draw_offset_square (s,colour,size)
    glRotatef (180,0,1,0)
    draw_offset_square (s,colour,size)
    
          	
    glPopMatrix()

# new window size or exposure

def set_model_view_matrix ():
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    camera_distance = 20
    clipping_width = 1
    glFrustum ( -5.5, 5.5, -5.5, 5.5, camera_distance - clipping_width, camera_distance + clipping_width) 
    glTranslatef (-5,-5,-camera_distance)

def reshape(width, height):
    
    glViewport(0, 0, width, height)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    #glOrtho ( -0.5, 10.5, -0.5, 10.5, 0, 2) 
    camera_distance = 20
    clipping_width = 1
    #glFrustum ( -5.5, 5.5, -5.5, 5.5, camera_distance - clipping_width, camera_distance + clipping_width) 
    gluPerspective   	(	45, float(width)/height, 1 , 1000 )
    glTranslatef (-5,-5,-camera_distance)
             

    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

def set_camera_pos (p):
    global camera_pos
    camera_pos = p
def get_camera_pos ():
    return camera_pos
def set_camera_angle (p):
    global camera_pos
    camera_pos = p
def get_camera_angle ():
    return camera_pos
    	
def bind_texture (name):
    glBindTexture(GL_TEXTURE_2D,lib.texture_manager.getTexture(name))
def init_textures ():
    glTexEnvfv( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE )
    
    
def init():
    glutInit(sys.argv)
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE |GLUT_DEPTH)
              
    glutInitWindowPosition(0, 0)
    glutInitWindowSize(500, 500)
    glutCreateWindow("Robots")
    
    init_textures ()
	
    glutReshapeFunc(reshape)
    glClearColor (1,1,0.5,1)
    glEnable(GL_NORMALIZE)
    glEnable(GL_LIGHTING)
    glEnable(GL_LIGHT1)
    glEnable( GL_TEXTURE_2D )
    #glDisable(GL_LIGHT0)
    glEnable(GL_DEPTH_TEST)
    glLight (GL_LIGHT1,GL_POSITION,[0,0,5,1])
    glLight (GL_LIGHT1,GL_DIFFUSE,[1,1,1])
    #glLight (GL_LIGHT1,GL_AMBIENT,[0,0,0])

def render_start ():
    glClear(GL_DEPTH_BUFFER_BIT)
    glClear(GL_COLOR_BUFFER_BIT)
    
def render_end ():
    glutSwapBuffers()

    
