"""
 This file is part of Space Robodyssey.

    Space Robodyssey is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Space Robodyssey is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Space Robodyssey.  If not, see <http://www.gnu.org/licenses/>.
"""
import os, pygame, pygame.image
from OpenGL.GL import *
from OpenGL.GLU import *

TEXTURES = {}

def add_texture (filename):
    tex = glGenTextures (1)

    glBindTexture(GL_TEXTURE_2D,tex)
    glTexParameter( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST )
    glTexParameter( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR )
    glTexParameter( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
    glTexParameter( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )

    img =pygame.image.load(filename)
    size = pygame.Surface.get_size(img)
    gluBuild2DMipmaps (GL_TEXTURE_2D,GL_RGBA,size[0],size[1],GL_RGBA,GL_UNSIGNED_BYTE,pygame.image.tostring (img,"RGBX"))
    return tex

def loadTextures(textureNames):
    for texture in textureNames:
        textureName = os.path.join('data', textureNames[texture])
        textureID = add_texture(textureName)
        TEXTURES[texture] = textureID

def getTexture(textureName):
    return TEXTURES[textureName]
